codeforces 999D Equalize the Remainders

2024-04-05 21:08

本文主要是介绍codeforces 999D Equalize the Remainders,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目:点击打开链接

题意:给你一个含有n个整数的数组a1,a2,…,an,和一个正整数m。保证m是n的因数。 在单次移动中,你可以选择在1到n之间的任一位置的数ai加1. 计算cr(0~m-1)——每个元素除以m之后的余数r。换句话说,对于每个余数, 找到与它相对应的元素。 你的任务是改变数组的元素使得c0=c1=…=cm-1=n/m; 找到满足上述要求的最小的需要改变的次数 。

分析:贪心,首先记录每个取余m后的结果数的个数,如果个数不大于n/m则不用改变,否则(需要改变)插入set,然后二分查找出大于该数的且余数个数小于n/m的数,把数组变化,同时更新对应值。注意如果找不到大于该数的且余数个数小于n/m的数,就是小于它的第一个数。具体细节见代码。主要熟悉了set和auto的用法。后又参考大佬的代码,他是边读边处理的结果是一样的。代码能力还有待提高啊。

我的代码:

#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstring>
#include<string>
#include<cmath>
#include<cstdlib>
#include<ctime>
#include<set>
#include<map>
#include<stack>
#include<queue>
using namespace std;
#define ll long long
#define pb push_back
#define inf 0x3f3f3f3f
#define eps 1e-10
const int N = 3e5+10;ll n,m,cnt[N],tp[N];
ll a[N];int main() {ios::sync_with_stdio(0);cin.tie(0);cin>>n>>m;ll k=n/m;for(int i=1;i<=n;i++) {cin>>a[i];cnt[a[i]%m]++;}set<ll> s;for(ll i=0;i<m;i++)if(cnt[i]<k) s.insert(i);ll ans=0;for(ll i=1;i<=n;i++) {if(cnt[a[i]%m]<=k) continue;auto it=s.lower_bound(a[i]%m);if( it!=s.end() ) {ans += (*it-a[i]%m);cnt[a[i]%m]--;cnt[*it]++;a[i]+=(*it-a[i]%m);if(cnt[*it]>=k) s.erase(*it);}else {ans += (m-(a[i]%m-*s.begin()));cnt[a[i]%m]--;cnt[*s.begin()]++;a[i]+=(m-(a[i]%m-*s.begin()));if( cnt[*s.begin()]>=k) s.erase(*s.begin());}}cout<<ans<<endl;for(int i=1;i<=n;i++){cout<<a[i];if(i!=n) cout<<" ";}return 0;
}


大佬的代码:

#include<iostream>
#include<algorithm>
#include<set>
using namespace std;
typedef long long ll;
const int N=2e5+6;
set<ll>st;
//cnt数组用来存0~m-1位置的所有的余数的个数都为n/m
//arr数组用来存输入的数组,以及改变后的数组
//res用来存当前值的余数
//val用来存应该最优应该选取的余数的值。
//ans用来存需要改变的操作数 
ll n,m,cnt[N],arr[N],res,val,ans;
int main(){cin>>n>>m;for(int i=0;i<m;cnt[i++]=n/m)st.insert((ll)i);for(int i=0;i<n;i++){cin>>arr[i];res=arr[i]%m;//贪心部分 if(res>*st.rbegin())val=*st.begin(); else val= *st.lower_bound(res);//贪心部分 ans=ans+(val-res+m)%m;if(!--cnt[val])st.erase(val);arr[i]=arr[i]+(val-res+m)%m;}cout<<ans<<endl;for(int i=0;i<n;i++)cout<<arr[i]<<" ";
}

这篇关于codeforces 999D Equalize the Remainders的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/878151

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

Codeforces#295(Div.2)A、B(模拟+BFS)

解题报告链接:点击打开链接 C. 题目链接:点击打开链接 解题思路: 对于给定的字符串,取出现次数最多的字母(可以同时有多个)。由这些字母组成长度为n的字符串,求有多少种组合。最后用数学知识即可。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <climits>

Codeforces Round #281 (Div. 2)A(构造+暴力模拟)

题目链接:http://codeforces.com/problemset/problem/493/A 解题思路: 暴力的判断,分三种情况去判断即可。注意如果之前已经被罚下场后,那么在后面的罚下情况不应该算在输出结果内。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <co

Codeforces Round #182 (Div. 2)A(水题)

题目链接:http://codeforces.com/contest/302/problem/A 解题思路: 只要通过重新排列使区间内和为0即是1,否则是0. 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <complex>#include <cstdio>#inc

Codeforces Round #233 (Div. 2)A(构造)

题目链接:http://codeforces.com/contest/399/problem/A 解题思路: 构造出来即可,考虑p-k和p+k两个边界分别于1和n作比较,对左右符号特殊处理。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <complex>#include